﻿#Region " Imports "
Imports GridGroupedColumn
Imports Infragistics.Web.UI.GridControls
Imports Tsql
Imports System.Collections.ObjectModel
#End Region

''' <summary>
''' Class GridGroupedColumnCollection
''' </summary>
<Serializable()> _
Public Class GridGroupedColumnCollection
    Inherits System.Collections.ObjectModel.KeyedCollection(Of String, GridGroupedColumn)

#Region "Constructors"
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByVal groupedColumns As Infragistics.Web.UI.GridControls.GroupedColumns)
        MyBase.new()
        Me.Parse(groupedColumns)
    End Sub

    Public Sub New(ByVal strGroupBy As String)
        MyBase.New()
        Me.Parse(strGroupBy)
    End Sub
#End Region

#Region "Properties"

#End Region

#Region "Methods"
    ''' <summary>
    ''' Adds the range.
    ''' </summary>
    ''' <param name="groupedColumns">The grouped columns.</param>
    Public Sub AddRange(ByVal groupedColumns As GridGroupedColumnCollection)
        For Each groupedColumn As GridGroupedColumn In groupedColumns
            Me.Add(groupedColumn)
        Next
    End Sub

    Public Sub Parse(ByVal groupedColumns As Infragistics.Web.UI.GridControls.GroupedColumns)
        If (groupedColumns Is Nothing) Then
            Exit Sub
        End If

        Me.Clear()

        If (groupedColumns.Count = 0) Then
            Exit Sub
        End If
        For Each grpcolumn As GroupedColumn In groupedColumns
            Dim scGroupBy As New GridGroupedColumn(grpcolumn)
            Me.Add(scGroupBy)
        Next
    End Sub

    Public Sub Parse(ByVal strGroupBy As String)
        If (strGroupBy Is Nothing) Then
            Exit Sub
        End If

        Me.Clear()

        If (strGroupBy.Length = 0) Then
            Exit Sub
        End If

        Dim strParts() As String = strGroupBy.Split(Keyword.FieldDelimiter)
        Dim nPart As Integer
        For nPart = 0 To strParts.Length - 1

            Dim ggColumn As New GridGroupedColumn(strParts(nPart).Trim())
            Me.Add(ggColumn)
        Next
    End Sub

    Public Overrides Function ToString() As String

        Dim strCriteria As String = ""
        Dim strGrouped As String = ""
        Dim scGrouped As GridGroupedColumn

        For Each scGrouped In Me
            strCriteria = scGrouped.ToString
            If Not (strCriteria.Length = 0) Then
                If Not (strGrouped.Length = 0) Then
                    strGrouped = String.Concat(strGrouped, Keyword.FieldDelimiter)
                End If
                strGrouped = String.Concat(strGrouped, strCriteria)
            End If
        Next
        Return strGrouped

    End Function

    ''' <summary>
    ''' Gets an SQL group criteria string from a <c>GridGroupedColumnCollection</c>.
    ''' </summary>
    Public Function ToSql() As String

        Dim strCriteria As String
        Dim strSql As String = Nothing
        Dim scGroupBy As GridGroupedColumn

        If (Me.Count = 0) Then
            Return String.Empty
        End If

        For Each scGroupBy In Me
            strCriteria = scGroupBy.ToSql
            If Not (strCriteria.Length = 0) Then
                If Not (strSql Is Nothing) Then
                    strSql = String.Concat(strSql, Keyword.FieldDelimiter)
                End If
                strSql = String.Concat(strSql, strCriteria)
            End If
        Next
        Return strSql

    End Function
#End Region

#Region " Overrides "
    ''' <summary>
    ''' Gets the key for an item.
    ''' </summary>
    ''' <param name="item">The item.</param>
    ''' <returns>System.String.</returns>
    Protected Overrides Function GetKeyForItem(item As GridGroupedColumn) As String
        Return item.Name
    End Function
#End Region

End Class