﻿/// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
/// Form specific methods
/// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$(document).ready(function () {
    $(document).on("layout", document_onLayout);
    $(window).on("resize", window_onResize);
    $(window).on("load", window_onLoad);
});

function window_onLoad() {
    $(document).trigger("layout");
}

function document_onLayout() {
    // Size the grid
    var nAvailableHeight = getAvailableHeight($("form:first").get(0));
    $(".igg_Control").each(function () {
        nHeight = nAvailableHeight + $(this).outerHeight(true);
        //setGridHeight(this, nHeight);
    });
}

function window_onResize() {
    $(document).trigger("layout");
}

/// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
/// Common methods
/// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
(function ($) {
    var scrollbarWidth = 0;
    $.getScrollbarWidth = function () {
        if (!scrollbarWidth) {
            if (typeof $.browser != "undefined") {
                if ($.browser.msie) {
                    var $textarea1 = $('<textarea cols="10" rows="2"></textarea>')
						    .css({ position: 'absolute', top: -1000, left: -1000 }).appendTo('body'),
					    $textarea2 = $('<textarea cols="10" rows="2" style="overflow: hidden;"></textarea>')
						    .css({ position: 'absolute', top: -1000, left: -1000 }).appendTo('body');
                    scrollbarWidth = $textarea1.width() - $textarea2.width();
                    $textarea1.add($textarea2).remove();
                    return scrollbarWidth;
                }
            }
            var $div = $('<div />')
				.css({ width: 100, height: 100, overflow: 'auto', position: 'absolute', top: -1000, left: -1000 })
				.prependTo('body').append('<div />').find('div')
					.css({ width: '100%', height: 200 });
            scrollbarWidth = 100 - $div.width();
            $div.parent().remove();
        }
        return scrollbarWidth;
    };
})(jQuery);

function getAvailableHeight(eContainer) {
    /// <summary>
    /// Gets the available wheightith inside an element.
    /// </summary>
    /// <returns>
    /// <c>null</c> if no element is specified; otherwise the available height inside the element.
    /// NOTE: The available height may be negative.
    /// </returns>
    /// <remarks>
    /// Tha available height is the space inside the element that isn't occupied by a child element.
    /// Assumes that all child elements inside the given element are to appear in a single column.
    /// </remarks>

    if (!eContainer) {
        // no parent
        return;
    }

    // Get the height of the element's children
    var $container = $(eContainer);
    var nChildrenHeight = 0;
    var $element;
    $container.children().not("script").each(function () {
        $element = $(this);
        if ($element.is(":visible")) {
            nChildrenHeight += $element.outerHeight(true);
        }
    });

    return $container.height() - nChildrenHeight;
}

function getAvailableWidth(eContainer) {
    /// <summary>
    /// Gets the available width inside an element.
    /// </summary>
    /// <returns>
    /// <c>null</c> if no element is specified; otherwise the available width inside the element.
    /// NOTE: The available width may be negative.
    /// </returns>
    /// <remarks>
    /// Tha available width is the space inside the element that isn't occupied by a child element.
    /// Assumes that all child elements inside the given element are to appear in a single row.
    /// </remarks>

    if (!eContainer) {
        // No container element
        return;
    }

    // Get the width of the element's children
    var $container = $(eContainer);
    var nChildrenWidth = 0;
    var $element;
    $container.children().not("script").each(function () {
        $element = $(this);
        if ($element.is(":visible")) {
            nChildrenWidth += $element.outerWidth(true);
        }
    });

    return ($container.width() - nChildrenWidth);
}

function maximizeHeight(eTarget, eContainer) {
    if (!eTarget) {
        // No target element
        return;
    }
    var $target = $(eTarget); // jQuery target object
    var nTargetHeight;
    if (eContainer) {
        // Size to container height
        nTargetHeight = $(eContainer).height();
        $target.outerHeight(nTargetHeight, true);
    } else {
        // Size to parent element's height allowing for visible siblings
        var eParent = $target.parent();
        if (!eParent) {
            // No parent
            return;
        }
        var $parent = $(eParent);
        var nAvailableHeight = getAvailableHeight(eParent);
        var nParentHeight = $parent.height();
        nTargetHeight = nAvailableHeight + $target.outerHeight(true);
        do {
            //Set target element height
            $target.outerHeight(nTargetHeight, true);
            // Ensure rounding hasn't increased the parent's height
            if ($parent.height() > nParentHeight) {
                nTargetHeight -= ($parent.height() - nParentHeight);
            } else {
                break;
            }
        } while (true);
    }
}

function maximizeWidth(eTarget, eContainer) {
    if (!eTarget) {
        // no parameter
        return;
    }
    var $target = $(eTarget); // jQuery target object
    var nTargetWidth;
    if (eContainer) {
        // Size to container width
        nTargetWidth = $(eContainer).width();
        $target.outerWidth(nTargetWidth, true);
    } else {
        // Size to parent width allowing for siblings
        var eParent = $target.parent();
        if (!eParent) {
            //No parent
            return;
        }
        var $parent = $(eParent);
        var nAvailableWidth = getAvailableWidth(eParent);
        var nParentWidth = $parent.width();
        nTargetWidth = nAvailableWidth + $target.outerWidth(true);
        do {
            // Set target element width
            $target.outerWidth(nTargetWidth, true);
            // Ensure rounding hasn't increased the parent's width
            if ($parent.width() > nParentWidth) {
                nTargetWidth -= ($parent.width() - nParentWidth);
            } else {
                break;
            }
        } while (true);
    }
}

function maximizeSize(eTarget, eContainer) {
    maximizeHeight(eTarget, eContainer);
    maximizeWidth(eTarget, eContainer);
}

// Additional logic with extra time-out to to resolve the issues in IE8.
// Occationally getting TypeError: Unable to get Property '_adjustGridLayout'
//                     of undefined or null reference.
function setGridHeight(eGrid, nHeight, bUseAdjustGridLayout) {

    if (!eGrid) {
        return;
    }

    // Set the grid height
    var $eGrid = $(eGrid);

    $eGrid.outerHeight(nHeight, true);

    // Set the content table width
    var $iggControl = $(".igg_Control", eGrid); //IE8
    var $outerTbl = $("[mkr='outerTbl.hdn']", eGrid);
    var $contentTbl = $("[mkr='contentTbl']", $outerTbl);

    $contentTbl.css({ "height": "",
        "width": ""
    });

    maximizeSize($iggControl[0], eGrid); //IE8
    maximizeSize($outerTbl[0], $iggControl[0]); //IE8

    // Clear the inline overflow that's added to the container element
    var $container = $("[mkr='container']", $outerTbl);
    $container.css("overflow", "");
    maximizeWidth($container[0], eGrid);
    maximizeHeight($container[0]);

    // Show the horizontal scroll bar
    //  Comparing contentTbl scrollWidth to the outerTbl width works for IE, other browsers need 
    //  to compare container width and grid width.
    if ($contentTbl.prop("scrollWidth") > $outerTbl.width() || $container.width() > $eGrid.width()) {
        var $hScrHeight = $("[mkr='hScrHeight']", $outerTbl);
        $hScrHeight.css("display", "");
        $hScrHeight.height("auto");
        //  IE8: Showing the horizontal scroll bar increases the outerTbl height so resulting in the
        //                        scrollbar being cropped off the bottom of the grid, adjust outerTbl height if required.
        var nOuterTblHeight = $outerTbl.outerHeight(true);
        var nGridHeight = $eGrid.height();
        if (nOuterTblHeight > nGridHeight) {
            var nContainerHeight = $container.outerHeight(true);
            $container.outerHeight(nContainerHeight - (nOuterTblHeight - nGridHeight), true);
        }
    }

    // Set horizontal scroll bar width allowing for the vertical scrollbar
    setTimeout(function () {
        var $hScrBar = $("[mkr='hScrBar']", $outerTbl);
        var nOffsetHeight = $container.prop("offsetHeight");
        var nScrollHeight = $container.prop("scrollHeight");
        if (nOffsetHeight < nScrollHeight) {
            $hScrBar.outerWidth($eGrid.prop("offsetWidth") - $.getScrollbarWidth(), true);
        } else {
            $hScrBar.outerWidth($eGrid.prop("offsetWidth"), true);
        }
    }, 100);

}

// On column sorting started event
function whdgWebHierarchicalDataGrid_onColumnSorting(sender, eventArgs) {

}

// On column sorting completed event
function whdgWebHierarchicalDataGrid_onColumnSorted(sender, eventArgs) {

}

// This event is also triggered when sorting grouped rows, not the normal grid grouping events
function whdgWebHierarchicalDataGrid_onGroupedColumnsChanging(sender, eventArgs) {
    var grid = sender;

}

// This event is also triggered when sorting grouped rows, not the normal grid grouping events
function whdgWebHierarchicalDataGrid_onGroupedColumnsChanged(sender, eventArgs) {

}

// Horizontal scroll bar disappears when changing the sort order on Find Now
function whdgWebHierarchicalDataGrid_onColumnSorted(sender, eventArgs) {
    setTimeout(function () {
        $(document).trigger("layout");
    }, 1);
}

// After collapsing/expanding fire the document layout event to show/hide scrollbars
function whdgWebHierarchicalDataGrid_onGroupedRowCollapsed(sender, eventArgs) {
    setTimeout(function () {
        $(document).trigger("layout");
    }, 1);
}

// After collapsing/expanding fire the document layout event to show/hide scrollbars
function whdgWebHierarchicalDataGrid_onGroupedRowExpanded(sender, eventArgs) {
    setTimeout(function () {
        $(document).trigger("layout");
    }, 1);
}